Архитектору и проектировщику|Тепло- и звукоизоляция URSA.RU
| Правила | Регистрация | Пользователи | Поиск | Сообщения за день | Все разделы прочитаны |  Справка по форуму | Файлообменник |

Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > .NET > Скрипт для построения полилинии по координатам в nanocad 10.0

Скрипт для построения полилинии по координатам в nanocad 10.0

Ответ
Поиск в этой теме
Непрочитано 27.12.2018, 15:37 #1
Скрипт для построения полилинии по координатам в nanocad 10.0
teodolit
 
Регистрация: 27.12.2018
Сообщений: 1

при помощью скрипта по координатам рисуются только точки (AddPoint), как изменить скрипт что бы по координатам строился полигон, не обязательно что бы это была полилиния
изменения в последней строке AddPoint на AddLine или AddLightWeightPolyline не к чему хороше не приводит

вот собственно сам скрипт
Код:
[Выделить все]
 var filename = ThisDrawing.Utility.ChooseFile("Select coordinate file", "Text Files (*.txt)|*.txt|All files (*.*)|*.*||");
var fso = new ActiveXObject("Scripting.FileSystemObject");
//var ts = fso.OpenTextFile("c:\\coords.txt", 1);
var ts = fso.OpenTextFile(filename, 1);

var done = false;
var re = /\s*,\s*/ // regular expression - splits by "," & remove unneeded spaces
var coords = new Array();
while (!done && !ts.AtEndOfStream)
{
  var s = ts.ReadLine();
  var sCoords = s.split(re);
  if (sCoords.length < 2)
  {
            done = true;
  } else
  {
            coords[0] = Number(sCoords[0]); // x coordinate
            coords[1] = Number(sCoords[1]); // y coordinate
            if (sCoords.length > 2)
                  coords[2] = Number(sCoords[2]); // z coordinate if exist
            else
                  coords[2] = 0;                                  // z coordinate omited
            var pt_coords = ThisDrawing.Utility.CreateTypedArrayFromJSArray(5, coords);
ThisDrawing.ModelSpace.AddPoint(pt_coords);
  }
}

Последний раз редактировалось Кулик Алексей aka kpblc, 27.12.2018 в 16:51.
Просмотров: 2303
 
Непрочитано 27.12.2018, 17:10
#2
Boxa

КЖ; C#
 
Регистрация: 03.11.2005
Санкт-Петербург
Сообщений: 2,063


teodolit, Вы справку то хоть смотрели? Не стесняйтесь, побалуйте себя этим и все станет намного проще.
В том числе справку по пространству имен System.IO, использование "Scripting.FileSystemObject" для чтения файла на C#.... это даже лучше чем if(a==true)

И в качестве PS: для прояснения ситуации, Вы пишите внешнее приложение, которое по COM взаимодействует с nanoCAD-ом?
__________________
_бложиг

Последний раз редактировалось Boxa, 27.12.2018 в 17:16.
Boxa на форуме  
 
Непрочитано 28.12.2018, 07:03
#3
trir


 
Регистрация: 18.12.2010
Сообщений: 3,459


Цитата:
что бы по координатам строился полигон
в AutoCAD это MPolygon, а в nanocad он есть?
trir на форуме  
 
Непрочитано 28.12.2018, 08:04
#4
frostmourn


 
Регистрация: 23.04.2015
Сообщений: 153


Переходите на лисп!
frostmourn вне форума  
 
Непрочитано 28.12.2018, 08:07
#5
Boxa

КЖ; C#
 
Регистрация: 03.11.2005
Санкт-Петербург
Сообщений: 2,063


Цитата:
Сообщение от trir Посмотреть сообщение
в AutoCAD это MPolygon, а в nanocad он есть?
Для автора, полигон - замкнутая линия, на форуме, ранее уже было подобное...
__________________
_бложиг
Boxa на форуме  
 
Непрочитано 28.12.2018, 08:11
#6
trir


 
Регистрация: 18.12.2010
Сообщений: 3,459


https://habr.com/company/nanosoft/blog/188188/

----- добавлено через ~9 мин. -----
Цитата:
использование "Scripting.FileSystemObject" для чтения файла на C#.... это даже лучше чем if(a==true)
это не C#
trir на форуме  
 
Непрочитано 28.12.2018, 08:49
#7
Boxa

КЖ; C#
 
Регистрация: 03.11.2005
Санкт-Петербург
Сообщений: 2,063


Цитата:
Сообщение от trir Посмотреть сообщение
Допустим, но почему тогда тема в разделе .NET ?
__________________
_бложиг
Boxa на форуме  
 
Непрочитано 28.12.2018, 09:08
#8
Кулик Алексей aka kpblc
Moderator

LISP, C# (ACAD 200[9,12,13,14])
 
Регистрация: 25.08.2003
С.-Петербург
Сообщений: 36,742


Это я ее перенес. Сначала вообще была в "Прочем программном обеспечении". Если должно быть в другом разделе - сообщи, перетащу. Не особо проблема.
__________________

---
Обращение ко мне - на "ты".
Все, что сказано - личное мнение.
Кулик Алексей aka kpblc вне форума  
Ответ
Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > .NET > Скрипт для построения полилинии по координатам в nanocad 10.0

Размещение рекламы
Опции темы Поиск в этой теме
Поиск в этой теме:

Расширенный поиск


Похожие темы
Тема Автор Раздел Ответов Последнее сообщение
LISP для расстановки полилиний вдоль другой полилинии Alex II LISP 0 03.03.2018 00:41
Построение фланцевого соединения со штуцером. Фланцы ГОСТ 12815-80. protorgovec Готовые программы 13 29.05.2016 17:09
Различные продукты nanoCAD . Помогите в выборе. Alexandr_A Другие CAD системы 11 18.06.2015 12:42
ищу функцию построения 3d полилинии mankurt Программирование 8 07.02.2012 12:43
Постороение полилинии по координатам в файле стран_ник AutoCAD 2 18.02.2010 12:21